Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/Weapon.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/Weapon.cc	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/Weapon.cc	(revision 2918)
@@ -22,4 +22,5 @@
  *   Author:
  *      Martin Polak
+ *      Fabian 'x3n' Landau
  *   Co-authors:
  *      ...
@@ -33,5 +34,5 @@
 #include "core/XMLPort.h"
 
-#include "Munition.h"
+#include "WeaponMode.h"
 #include "WeaponPack.h"
 #include "WeaponSystem.h"
@@ -45,17 +46,11 @@
         RegisterObject(Weapon);
 
-        this->bulletReadyToShoot_ = true;
-        this->magazineReadyToShoot_ = true;
-        this->weaponSystem_ = 0;
         this->weaponPack_ = 0;
         this->weaponSlot_ = 0;
-        this->bulletLoadingTime_ = 0;
-        this->magazineLoadingTime_ = 0;
         this->bReloading_ = false;
-        this->bulletAmount_= 0;
-        this->magazineAmount_ = 0;
-        this->munition_ = 0;
-        this->unlimitedMunition_ = false;
-        this->setObjectMode(0x0);
+        this->reloadingWeaponmode_ = WeaponSystem::WEAPON_MODE_UNASSIGNED;
+
+        this->reloadTimer_.setTimer(0.0f, false, this, createExecutor(createFunctor(&Weapon::reloaded)));
+        this->reloadTimer_.stopTimer();
 
 COUT(0) << "+Weapon" << std::endl;
@@ -65,6 +60,13 @@
     {
 COUT(0) << "~Weapon" << std::endl;
-        if (this->isInitialized() && this->weaponPack_)
-            this->weaponPack_->removeWeapon(this);
+
+        if (this->isInitialized())
+        {
+            if (this->weaponPack_)
+                this->weaponPack_->removeWeapon(this);
+
+            for (std::multimap<unsigned int, WeaponMode*>::iterator it = this->weaponmodes_.begin(); it != this->weaponmodes_.end(); ++it)
+                delete it->second;
+        }
     }
 
@@ -73,167 +75,80 @@
         SUPER(Weapon, XMLPort, xmlelement, mode);
 
-        XMLPortParam(Weapon, "munitionType", setMunitionType, getMunitionType, xmlelement, mode);
-        XMLPortParam(Weapon, "bulletLoadingTime", setBulletLoadingTime, getBulletLoadingTime, xmlelement, mode);
-        XMLPortParam(Weapon, "magazineLoadingTime", setMagazineLoadingTime, getMagazineLoadingTime, xmlelement, mode);
-        XMLPortParam(Weapon, "bullets", setBulletAmount, getBulletAmount, xmlelement, mode);
-        XMLPortParam(Weapon, "magazines", setMagazineAmount, getMagazineAmount, xmlelement, mode);
-        XMLPortParam(Weapon, "unlimitedMunition", setUnlimitedMunition, getUnlimitedMunition, xmlelement, mode);
+        XMLPortObject(Weapon, WeaponMode, "", addWeaponmode, getWeaponmode, xmlelement, mode);
     }
 
-    void Weapon::setWeapon()
+    void Weapon::addWeaponmode(WeaponMode* weaponmode)
     {
-        this->munition_->fillBullets();
-        this->munition_->fillMagazines();
+        if (!weaponmode)
+            return;
+
+        this->weaponmodes_.insert(std::pair<unsigned int, WeaponMode*>(weaponmode->getMode(), weaponmode));
+        weaponmode->setWeapon(this);
     }
 
-    void Weapon::setMunition()
+    WeaponMode* Weapon::getWeaponmode(unsigned int index) const
     {
-        this->munition_->setMaxBullets(this->bulletAmount_);
-        this->munition_->setMaxMagazines(this->magazineAmount_);
+        unsigned int i = 0;
+        for (std::multimap<unsigned int, WeaponMode*>::const_iterator it = this->weaponmodes_.begin(); it != this->weaponmodes_.end(); ++it)
+        {
+            if (i == index)
+                return it->second;
+
+            ++i;
+        }
+        return 0;
     }
 
-    void Weapon::fire()
+    void Weapon::fire(unsigned int mode)
     {
-        if ( this->bulletReadyToShoot_ && this->magazineReadyToShoot_ && !this->bReloading_)
+        // To avoid firing with more than one mode at the same time, we lock the weapon (reloading) for
+        // all modes except the one which is currently reloading.
+        //
+        // Example:
+        // WeaponMode A -> mode 0
+        // WeaponMode B -> mode 0
+        // WeaponMode C -> mode 1
+        //
+        // -> A and B can fire at the same time, but C has to wait until both (A and B) have reloaded
+        // -> If C fires, A and B have to wait until C has reloaded
+        //
+        // Note: The reloading of each WeaponMode is internally handled by each A, B and C.
+        //       The reloading of the weapon is only performed to avoid firing with different modes at the same time.
+        if (this->bReloading_ && this->reloadingWeaponmode_ != mode)
+            return;
+
+        std::multimap<unsigned int, WeaponMode*>::iterator start = this->weaponmodes_.lower_bound(mode);
+        std::multimap<unsigned int, WeaponMode*>::iterator end   = this->weaponmodes_.upper_bound(mode);
+
+        for (std::multimap<unsigned int, WeaponMode*>::iterator it = start; it != end; ++it)
         {
-            this->bulletReadyToShoot_ = false;
-            if ( this->unlimitedMunition_== true )
+            float reloading_time = 0;
+            if (it->second->fire(&reloading_time))
             {
-                //shoot
-                this->reloadBullet();
-                this->createProjectile();
-            }
-            else
-            {
-                if ( this->munition_->bullets() > 0)
-                {
-                    //shoot and reload
-                    this->takeBullets();
-                    this->reloadBullet();
-                    this->createProjectile();
-                }
-                //if there are no bullets, but magazines
-                else if ( this->munition_->magazines() > 0 && this->munition_->bullets() == 0 )
-                {
-                    //reload magazine
-                    this->takeMagazines();
-                    this->reloadMagazine();
-                }
-                else
-                {
-                    //no magazines
-                }
-            }
-        }
-        else
-        {
-            //weapon not reloaded
-        }
+                this->bReloading_ = true;
+                this->reloadingWeaponmode_ = mode;
 
-    }
-
-
-    //weapon reloading
-    void Weapon::bulletTimer(float bulletLoadingTime)
-    {
-        this->bReloading_ = true;
-        this->bulletReloadTimer_.setTimer( bulletLoadingTime , false , this , createExecutor(createFunctor(&Weapon::bulletReloaded)));
-    }
-    void Weapon::magazineTimer(float magazineLoadingTime)
-    {
-        this->bReloading_ = true;
-        this->magazineReloadTimer_.setTimer( magazineLoadingTime , false , this , createExecutor(createFunctor(&Weapon::magazineReloaded)));
-    }
-
-    void Weapon::bulletReloaded()
-    {
-        this->bReloading_ = false;
-        this->bulletReadyToShoot_ = true;
-    }
-
-    void Weapon::magazineReloaded()
-    {
-        this->bReloading_ = false;
-        this->munition_->fillBullets();
-    }
-
-
-
-    void Weapon::attachNeededMunition(const std::string& munitionName)
-    {
-        /*  if munition type already exists attach it, else create a new one of this type and attach it to the weapon and to the WeaponSystem
-        */
-        if (this->weaponSystem_)
-        {
-            //getMunitionType returns 0 if there is no such munitionType
-            Munition* munition = this->weaponSystem_->getMunitionType(munitionName);
-            if ( munition )
-            {
-                this->munition_ = munition;
-                this->setMunition();
-            }
-            else
-            {
-                //create new munition with identifier because there is no such munitionType
-                this->munitionIdentifier_ = ClassByString(munitionName);
-                this->munition_ = this->munitionIdentifier_.fabricate(this);
-                this->weaponSystem_->setNewMunition(munitionName, this->munition_);
-                this->setMunition();
+                this->reloadTimer_.setInterval(reloading_time);
+                this->reloadTimer_.startTimer();
             }
         }
     }
 
-
-    Munition * Weapon::getAttachedMunition(const std::string& munitionType)
+    void Weapon::reload()
     {
-        this->munition_ = this->weaponSystem_->getMunitionType(munitionType);
-        return this->munition_;
+        for (std::multimap<unsigned int, WeaponMode*>::iterator it = this->weaponmodes_.begin(); it != this->weaponmodes_.end(); ++it)
+            it->second->reload();
     }
 
+    void Weapon::reloaded()
+    {
+        this->bReloading_ = false;
+        this->reloadingWeaponmode_ = WeaponSystem::WEAPON_MODE_UNASSIGNED;
+    }
 
-    //these function are defined in the weapon classes
-    void Weapon::takeBullets() { };
-    void Weapon::createProjectile() { };
-    void Weapon::takeMagazines() { };
-    void Weapon::reloadBullet() { };
-    void Weapon::reloadMagazine() { };
-
-
-    //get and set functions for XMLPort
-    void Weapon::setMunitionType(const std::string& munitionType)
-    {   this->munitionType_ = munitionType; }
-
-    const std::string& Weapon::getMunitionType() const
-    {   return this->munitionType_;  }
-
-    void Weapon::setBulletLoadingTime(float loadingTime)
-    {   this->bulletLoadingTime_ = loadingTime; }
-
-    const float Weapon::getBulletLoadingTime() const
-    {   return this->bulletLoadingTime_;  }
-
-    void Weapon::setMagazineLoadingTime(float loadingTime)
-    {   this->magazineLoadingTime_ = loadingTime; }
-
-    const float Weapon::getMagazineLoadingTime() const
-    {   return this->magazineLoadingTime_;  }
-
-    void Weapon::setBulletAmount(unsigned int amount)
-    {   this->bulletAmount_ = amount; }
-
-    const unsigned int Weapon::getBulletAmount() const
-    {   return this->bulletAmount_;  }
-
-    void Weapon::setMagazineAmount(unsigned int amount)
-    {   this->magazineAmount_ = amount; }
-
-    const unsigned int Weapon::getMagazineAmount() const
-    {   return this->magazineAmount_;   }
-
-    void Weapon::setUnlimitedMunition(bool unlimitedMunition)
-    {   this->unlimitedMunition_ = unlimitedMunition;   }
-
-    const bool Weapon::getUnlimitedMunition() const
-    {   return this->unlimitedMunition_;    }
-
+    void Weapon::notifyWeaponModes()
+    {
+        for (std::multimap<unsigned int, WeaponMode*>::iterator it = this->weaponmodes_.begin(); it != this->weaponmodes_.end(); ++it)
+            it->second->setWeapon(this);
+    }
 }
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/Weapon.h
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/Weapon.h	(revision 2917)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/Weapon.h	(revision 2918)
@@ -22,4 +22,5 @@
  *   Author:
  *      Martin Polak
+ *      Fabian 'x3n' Landau
  *   Co-authors:
  *      ...
@@ -34,5 +35,4 @@
 
 #include "tools/Timer.h"
-#include "core/Identifier.h"
 
 namespace orxonox
@@ -46,48 +46,14 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
 
-            virtual void fire();
-            void attachNeededMunition(const std::string& munitionType);
-            Munition * getAttachedMunition(const std::string& munitiontype);
+            void fire(unsigned int mode);
+            void reload();
 
-            //reloading
-            void bulletTimer(float bulletLoadingTime);
-            void magazineTimer(float magazineLoadingTime);
-            void bulletReloaded();
-            void magazineReloaded();
+            void addWeaponmode(WeaponMode* weaponmode);
+            WeaponMode* getWeaponmode(unsigned int index) const;
 
-            //XMLPort functions
-            virtual void setMunitionType(const std::string& munitionType);
-            virtual const std::string& getMunitionType() const;
-            virtual void setBulletLoadingTime(float loadingTime);
-            virtual const float getBulletLoadingTime() const;
-            virtual void setMagazineLoadingTime(float loadingTime);
-            virtual const float getMagazineLoadingTime() const;
-            virtual void setBulletAmount(unsigned int amount);
-            virtual const unsigned int getBulletAmount() const;
-            virtual void setMagazineAmount(unsigned int amount);
-            virtual const unsigned int getMagazineAmount() const;
-            virtual void setUnlimitedMunition(bool unlimitedMunition);
-            virtual const bool getUnlimitedMunition() const;
-
-            //weapon actions
-            virtual void takeBullets();
-            virtual void takeMagazines();
-            virtual void createProjectile();
-            virtual void reloadBullet();
-            virtual void reloadMagazine();
-
-            //manually set or reset
-            virtual void setWeapon();
-            virtual void setMunition();
-
-            inline void setWeaponSystem(WeaponSystem *weaponSystem)
-                { this->weaponSystem_ = weaponSystem; };
-            inline WeaponSystem * getWeaponSystem() const
-                { return this->weaponSystem_; };
-
-            inline void setWeaponPack(WeaponPack *weaponPack)
-                { this->weaponPack_ = weaponPack; };
+            inline void setWeaponPack(WeaponPack * weaponPack)
+                { this->weaponPack_ = weaponPack; this->notifyWeaponModes(); }
             inline WeaponPack * getWeaponPack() const
-                { return this->weaponPack_; };
+                { return this->weaponPack_; }
 
             inline void setWeaponSlot(WeaponSlot * wSlot)
@@ -96,24 +62,15 @@
                 { return this->weaponSlot_; }
 
-        protected:
+        private:
+            void reloaded();
+            void notifyWeaponModes();
+
+            WeaponPack* weaponPack_;
+            WeaponSlot* weaponSlot_;
+            std::multimap<unsigned int, WeaponMode*> weaponmodes_;
+
+            Timer<Weapon> reloadTimer_;
             bool bReloading_;
-            bool bulletReadyToShoot_;
-            bool magazineReadyToShoot_;
-            bool unlimitedMunition_;
-            float bulletLoadingTime_;
-            float magazineLoadingTime_;
-            unsigned int bulletAmount_;
-            unsigned int magazineAmount_;
-            std::string munitionType_;
-
-            WeaponSlot * weaponSlot_;
-            Munition * munition_;
-            WeaponSystem * weaponSystem_;
-            WeaponPack* weaponPack_;
-
-            SubclassIdentifier<Munition> munitionIdentifier_;
-
-            Timer<Weapon> bulletReloadTimer_;
-            Timer<Weapon> magazineReloadTimer_;
+            unsigned int reloadingWeaponmode_;
     };
 }
Index: /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponMode.cc
===================================================================
--- /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponMode.cc	(revision 2918)
+++ /code/branches/weapons/src/orxonox/objects/weaponSystem/WeaponMode.cc	(revision 2918)
@@ -0,0 +1,372 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Martin Polak
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "OrxonoxStableHeaders.h"
+#include "WeaponMode.h"
+
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+
+#include "Munition.h"
+#include "Weapon.h"
+#include "WeaponPack.h"
+#include "WeaponSystem.h"
+
+namespace orxonox
+{
+    WeaponMode::WeaponMode(BaseObject* creator) : BaseObject(creator)
+    {
+        RegisterObject(WeaponMode);
+
+        this->weapon_ = 0;
+        this->mode_ = WeaponSystem::WEAPON_MODE_UNASSIGNED;
+
+        this->munition_ = 0;
+        this->initialMunition_ = 0;
+        this->initialMagazines_ = 0;
+        this->munitionPerShot_ = 1;
+
+        this->reloadTime_ = 0.25;
+        this->bReloading_ = false;
+        this->bAutoReload_ = true;
+        this->bParallelReload_ = true;
+
+        this->reloadTimer_.setTimer(0.0f, false, this, createExecutor(createFunctor(&WeaponMode::reloaded)));
+        this->reloadTimer_.stopTimer();
+
+        this->damage_ = 0;
+        this->muzzleOffset_ = Vector3::ZERO;
+
+COUT(0) << "+WeaponMode" << std::endl;
+    }
+
+    WeaponMode::~WeaponMode()
+    {
+COUT(0) << "~WeaponMode" << std::endl;
+    }
+
+    void WeaponMode::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(WeaponMode, XMLPort, xmlelement, mode);
+
+        XMLPortParam(WeaponMode, "mode",             setMode,             getMode,             xmlelement, mode);
+
+        XMLPortParam(WeaponMode, "munitiontype",     setMunitionName,     getMunitionName,     xmlelement, mode);
+        XMLPortParam(WeaponMode, "initialmunition",  setInitialMunition,  getInitialMunition,  xmlelement, mode);
+        XMLPortParam(WeaponMode, "initialmagazines", setInitialMagazines, getInitialMagazines, xmlelement, mode);
+        XMLPortParam(WeaponMode, "munitionpershot",  setMunitionPerShot,  getMunitionPerShot,  xmlelement, mode);
+
+        XMLPortParam(WeaponMode, "reloadtime",       setReloadTime,       getReloadTime,       xmlelement, mode);
+        XMLPortParam(WeaponMode, "autoreload",       setAutoReload,       getAutoReload,       xmlelement, mode).description("If true, the weapon reloads the magazine automatically");
+        XMLPortParam(WeaponMode, "parallelreload",   setParallelReload,   getParallelReload,   xmlelement, mode).description("If true, the weapon reloads in parallel to the magazine reloading");
+
+        XMLPortParam(WeaponMode, "damage",           setDamage,           getDamage,           xmlelement, mode);
+        XMLPortParam(WeaponMode, "muzzleoffset",     setMuzzleOffset,     getMuzzleOffset,     xmlelement, mode);
+    }
+
+    bool WeaponMode::fire(float* reloadTime)
+    {
+        (*reloadTime) = this->reloadTime_;
+
+        if (!this->bReloading_ && this->munition_ && this->munition_->takeMunition(this->munitionPerShot_, this))
+        {
+            float reloadtime = this->reloadTime_;
+
+            if (this->bAutoReload_ && this->munition_->needReload(this))
+            {
+                if (this->munition_->reload(this))
+                {
+                    if (!this->bParallelReload_)
+                        reloadtime += this->munition_->getReloadTime();
+                }
+            }
+
+            this->bReloading_ = true;
+            this->reloadTimer_.setInterval(reloadtime);
+            this->reloadTimer_.startTimer();
+
+            this->fire();
+
+            return true;
+        }
+        else
+        {
+            return false;
+        }
+    }
+
+    bool WeaponMode::reload()
+    {
+        if (this->munition_ && this->munition_->reload(this))
+        {
+            if (!this->bParallelReload_)
+            {
+                this->bReloading_ = true;
+                this->reloadTimer_.setInterval(this->reloadTime_ + this->munition_->getReloadTime());
+                this->reloadTimer_.startTimer();
+            }
+
+            return true;
+        }
+
+        return false;
+    }
+
+    void WeaponMode::setMunitionType(Identifier* identifier)
+    {
+        this->munitionname_ = identifier->getName();
+        this->munitiontype_ = identifier;
+        this->updateMunition();
+    }
+
+    void WeaponMode::setMunitionName(const std::string& munitionname)
+    {
+        this->munitionname_ = munitionname;
+        this->munitiontype_ = ClassByString(this->munitionname_);
+        this->updateMunition();
+    }
+
+    void WeaponMode::updateMunition()
+    {
+        if (this->munitiontype_ && this->weapon_ && this->weapon_->getWeaponPack() && this->weapon_->getWeaponPack()->getWeaponSystem())
+        {
+            this->munition_ = this->weapon_->getWeaponPack()->getWeaponSystem()->getMunition(&this->munitiontype_);
+
+            if (this->munition_)
+            {
+                // Add the initial magazines
+                this->munition_->addMagazines(this->initialMagazines_);
+
+                // Maybe we have to reload (if this munition is used the first time or if there weren't any magazines available before)
+                if (this->munition_->needReload(this))
+                    this->munition_->reload(this, false);
+
+                // Add the initial munition
+                if (this->initialMunition_ > 0 && this->munition_->getNumMunitionInCurrentMagazine(this) == this->munition_->getMaxMunitionPerMagazine())
+                {
+                    // The current magazine is still full, so let's just add another magazine to
+                    // the stack and reduce the current magazine to the given amount of munition
+
+                    unsigned int initialmunition = this->initialMunition_;
+                    if (initialmunition > this->munition_->getMaxMunitionPerMagazine())
+                        initialmunition = this->munition_->getMaxMunitionPerMagazine();
+
+                    this->munition_->takeMunition(this->munition_->getMaxMunitionPerMagazine() - initialmunition, this);
+                    this->munition_->addMagazines(1);
+                }
+                else
+                {
+                    // The current magazine isn't full, add the munition directly
+
+                    this->munition_->addMunition(this->initialMunition_);
+                }
+            }
+        }
+        else
+            this->munition_ = 0;
+    }
+
+    void WeaponMode::reloaded()
+    {
+        this->bReloading_ = false;
+    }
+
+    Vector3 WeaponMode::getMuzzlePosition() const
+    {
+        if (this->weapon_)
+            return (this->weapon_->getWorldPosition() + this->muzzleOffset_);
+        else
+            return this->muzzleOffset_;
+    }
+
+    const Quaternion& WeaponMode::getMuzzleOrientation() const
+    {
+        if (this->weapon_)
+            return this->weapon_->getWorldOrientation();
+        else
+            return Quaternion::IDENTITY;
+    }
+
+    Vector3 WeaponMode::getMuzzleDirection() const
+    {
+        if (this->weapon_)
+            return (this->weapon_->getWorldOrientation() * WorldEntity::FRONT);
+        else
+            return WorldEntity::FRONT;
+    }
+
+/*
+    WeaponMode::WeaponMode(BaseObject* creator) : StaticEntity(creator)
+    {
+        RegisterObject(WeaponMode);
+
+        this->bulletReadyToShoot_ = true;
+        this->magazineReadyToShoot_ = true;
+        this->weaponSystem_ = 0;
+        this->weaponPack_ = 0;
+        this->weaponSlot_ = 0;
+        this->bulletLoadingTime_ = 0;
+        this->magazineLoadingTime_ = 0;
+        this->bReloading_ = false;
+        this->bulletAmount_= 0;
+        this->magazineAmount_ = 0;
+        this->munition_ = 0;
+        this->unlimitedMunition_ = false;
+        this->setObjectMode(0x0);
+COUT(0) << "+WeaponMode" << std::endl;
+    }
+
+    WeaponMode::~WeaponMode()
+    {
+COUT(0) << "~WeaponMode" << std::endl;
+        if (this->isInitialized() && this->weaponPack_)
+            this->weaponPack_->removeWeapon(this);
+    }
+
+    void WeaponMode::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(WeaponMode, XMLPort, xmlelement, mode);
+
+        XMLPortParam(WeaponMode, "munitionType", setMunitionType, getMunitionType, xmlelement, mode);
+        XMLPortParam(WeaponMode, "bulletLoadingTime", setBulletLoadingTime, getBulletLoadingTime, xmlelement, mode);
+        XMLPortParam(WeaponMode, "magazineLoadingTime", setMagazineLoadingTime, getMagazineLoadingTime, xmlelement, mode);
+        XMLPortParam(WeaponMode, "bullets", setBulletAmount, getBulletAmount, xmlelement, mode);
+        XMLPortParam(WeaponMode, "magazines", setMagazineAmount, getMagazineAmount, xmlelement, mode);
+        XMLPortParam(WeaponMode, "unlimitedMunition", setUnlimitedMunition, getUnlimitedMunition, xmlelement, mode);
+    }
+
+    void WeaponMode::setWeapon()
+    {
+        this->munition_->fillBullets();
+        this->munition_->fillMagazines();
+    }
+
+    void WeaponMode::setMunition()
+    {
+        this->munition_->setMaxBullets(this->bulletAmount_);
+        this->munition_->setMaxMagazines(this->magazineAmount_);
+    }
+
+    void WeaponMode::fire()
+    {
+        if ( this->bulletReadyToShoot_ && this->magazineReadyToShoot_ && !this->bReloading_)
+        {
+            this->bulletReadyToShoot_ = false;
+            if ( this->unlimitedMunition_== true )
+            {
+                //shoot
+                this->reloadBullet();
+                this->createProjectile();
+            }
+            else
+            {
+                if ( this->munition_->bullets() > 0)
+                {
+                    //shoot and reload
+                    this->takeBullets();
+                    this->reloadBullet();
+                    this->createProjectile();
+                }
+                //if there are no bullets, but magazines
+                else if ( this->munition_->magazines() > 0 && this->munition_->bullets() == 0 )
+                {
+                    //reload magazine
+                    this->takeMagazines();
+                    this->reloadMagazine();
+                }
+                else
+                {
+                    //no magazines
+                }
+            }
+        }
+        else
+        {
+            //weapon not reloaded
+        }
+    }
+
+
+    //weapon reloading
+    void WeaponMode::bulletTimer(float bulletLoadingTime)
+    {
+        this->bReloading_ = true;
+        this->bulletReloadTimer_.setTimer( bulletLoadingTime , false , this , createExecutor(createFunctor(&WeaponMode::bulletReloaded)));
+    }
+    void WeaponMode::magazineTimer(float magazineLoadingTime)
+    {
+        this->bReloading_ = true;
+        this->magazineReloadTimer_.setTimer( magazineLoadingTime , false , this , createExecutor(createFunctor(&WeaponMode::magazineReloaded)));
+    }
+
+    void WeaponMode::bulletReloaded()
+    {
+        this->bReloading_ = false;
+        this->bulletReadyToShoot_ = true;
+    }
+
+    void WeaponMode::magazineReloaded()
+    {
+        this->bReloading_ = false;
+        this->munition_->fillBullets();
+    }
+
+
+
+    void WeaponMode::attachNeededMunition(const std::string& munitionName)
+    {
+        //  if munition type already exists attach it, else create a new one of this type and attach it to the weapon and to the WeaponSystem
+        if (this->weaponSystem_)
+        {
+            //getMunitionType returns 0 if there is no such munitionType
+            Munition* munition = this->weaponSystem_->getMunitionType(munitionName);
+            if ( munition )
+            {
+                this->munition_ = munition;
+                this->setMunition();
+            }
+            else
+            {
+                //create new munition with identifier because there is no such munitionType
+                this->munitionIdentifier_ = ClassByString(munitionName);
+                this->munition_ = this->munitionIdentifier_.fabricate(this);
+                this->weaponSystem_->setNewMunition(munitionName, this->munition_);
+                this->setMunition();
+            }
+        }
+    }
+
+
+    Munition * WeaponMode::getAttachedMunition(const std::string& munitionType)
+    {
+        this->munition_ = this->weaponSystem_->getMunitionType(munitionType);
+        return this->munition_;
+    }
+*/
+}
